unit Servers.Frame;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.WinXCtrls, Vcl.StdCtrls;

type
  TFrameServer = class(TFrame)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    ToggleSwitch1: TToggleSwitch;
  private
    { Private declarations }
    fServerName:String;
    fServerIP:String;
    fServerActive:Boolean;
    procedure SetServeractive(const Value: Boolean);
    procedure SetServerIP(const Value: String);
    procedure SetServerName(const Value: String);
  public
    { Public declarations }
    property ServerName:String read fServerName write SetServerName;
    property ServerIP:String read fServerIP write SetServerIP;
    property ServerActive:Boolean read fServerActive write SetServeractive;

    constructor Create(AOwner:TComponent;
                       AServerName,
                       AServerIP:String;
                       AServerActive:Boolean);

    procedure Refresh();
  end;

implementation

{$R *.dfm}

{ TFrameServer }

constructor TFrameServer.Create(AOwner: TComponent;
                                AServerName,
                                AServerIP: String;
                                AServerActive: Boolean);
begin
     inherited Create(AOwner);

     Name:=Format('srv%s',[AServerName]);

     fServerName:=AServerName;
     fServerIP:=AServerIP;
     fServerActive:=AServerActive;

     Refresh();
end;

procedure TFrameServer.Refresh;
begin
     Edit1.Text:=ServerName;
     Edit2.Text:=ServerIP;

     ToggleSwitch1.State:=TToggleSwitchState(ServerActive);

     case ToggleSwitch1.State of
        TToggleSwitchState.tssOff: ToggleSwitch1.FrameColor:=clGray;
        TToggleSwitchState.tssOn: ToggleSwitch1.FrameColor:=clGreen;
     end;

     ToggleSwitch1.ThumbColor:=ToggleSwitch1.FrameColor;
end;

procedure TFrameServer.SetServeractive(const Value: Boolean);
begin
     fServerActive := Value;

     Refresh;
end;

procedure TFrameServer.SetServerIP(const Value: String);
begin
    fServerIP := Value;
    Refresh;
end;

procedure TFrameServer.SetServerName(const Value: String);
begin
    fServerName := Value;
    Refresh;
end;

end.
